# Author Darrell Best: bbest@g.clemson.edu
# Date 10/06/2014
#
# Singleton State class holds global variables

import time

from singleton import Singleton

@Singleton
class State:

    def __init__(self):
        self.mouse_velocity_coord = [0, 0]
        self.mouse_coord = [0, 0]
        self.eye_velocity_coord = [0, 0]
        self.eye_coord = [0, 0]
        self.window_res = [0, 0]
        self.screen = 23
        self.viewing_dist = 19.68
        self.butter_worth = 1
        self.interface = 1
        self.input = 0 # 1 is eye tracker, 0 is mouse
        self.dfwidth = 10
        self.dfdegree = 2
        self.dfo = 1
        self.threshold = 20
        self.fixating = 0
        self.recording = 0
        self.refs = list()
        self.pin = ""
        self.fix_start_time = time.time()
        self.fix_end_time = time.time()
        self.calibrating = 0
    
    def set_input(self, flag):
        self.input = flag

    def set_velocity_coord_x(self, x):
        self.mouse_velocity_coord[0] = x

    def set_velocity_coord_y(self, y):
        self.mouse_velocity_coord[1] = y

    def set_mouse_coord_x(self, x):
        self.mouse_coord[0] = x

    def set_mouse_coord_y(self, y):
        self.mouse_coord[1] = y
    
    def set_eye_coord_x(self, x):
        self.eye_coord[0] = x
    
    def set_eye_coord_y(self, y):
        self.eye_coord[1] = y

    def set_window_width(self, w):
        self.window_res[0] = w

    def set_window_height(self, h):
        self.window_res[1] = h
    
    def set_screen(self, s):
        self.screen = s

    def set_viewing_dist(self, d):
        self.viewing_dist = d

    def set_butter_worth(self, flag):
        self.butter_worth = flag
    
    def set_interface(self, flag):
        self.interface = flag
    
    def set_fixating(self, flag):
        self.fixating = flag
    
    def set_threshold(self,T):
        self.threshold = T
    
    def set_dfwidth(self,d):
        self.dfwidth = d

    def set_dfdegree(self,d):
        self.dfdegree = d

    def set_dfo(self,d):
        self.dfo = d
    
    def set_recording(self, flag):
        self.recording = flag
    
    def set_fix_start_time(self, time):
        self.fix_start_time = time
    
    def set_fix_end_time(self, time):
        self.fix_end_time = time
    
    def set_calibrating(self, flag):
        self.calibrating = flag

    def get_mouse_velocity_coord_x(self):
        return self.mouse_velocity_coord[0]
    
    def get_mouse_velocity_coord_y(self):
        return self.mouse_velocity_coord[1]
    
    def get_mouse_coord_x(self):
        return self.mouse_coord[0]
    
    def get_mouse_coord_y(self):
        return self.mouse_coord[1]
    
    def get_eye_velocity_coord_x(self):
        return self.eye_velocity_coord[0]
    
    def get_eye_velocity_coord_y(self):
        return self.eye_velocity_coord[1]
    
    def get_eye_coord_x(self):
        return self.eye_coord[0]
    
    def get_eye_coord_y(self):
        return self.eye_coord[1]
    
    def get_window_width(self):
        return self.window_res[0]
    
    def get_window_height(self):
        return self.window_res[1]

    def get_screen(self):
        return self.screen
    
    def get_viewing_dist(self):
        return self.viewing_dist
    
    def get_butter_worth(self):
        return self.butter_worth
    
    def get_input(self):
        return self.input
    
    def get_interface(self):
        return self.interface
    
    def get_dfwidth(self):
        return self.dfwidth

    def get_dfdegree(self):
        return self.dfdegree

    def get_dfo(self):
        return self.dfo
    
    def get_threshold(self):
        return self.threshold
    
    def get_fixating(self):
        return self.fixating

    def get_pin(self):
        return self.pin
    
    def get_refs(self):
        return self.refs
    
    def get_recording(self):
        return self.recording
    
    def get_fix_start_time(self):
        return self.fix_start_time
    
    def get_fix_end_time(self):
        return self.fix_end_time
    
    def get_calibrating(self):
        return self.calibrating
    
    def add_to_pin(self, i):
        self.pin.append(i)
    
    def add_to_refs(self, ref):
        self.refs.append(ref)

    def reset_pin(self):
        self.pin = ""

    def reset_refs(self):
        self.refs = list()

